.386
.model flat,stdcall
option casemap:none

include	   \masm32\include\windows.inc
include	   \masm32\include\kernel32.inc
include	   \masm32\include\user32.inc
include	   \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib comctl32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
EditBox PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

SetWindowSubclass PROTO :DWORD,:DWORD,:DWORD,:DWORD
DefSubclassProc   PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDC_EDIT = 4001


.data
Resource    db 'MYDIALOG',0

.code

start:

    invoke  GetModuleHandle,0
    invoke  DialogBoxParam,eax,ADDR Resource,NULL,ADDR DlgProc,0
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
    .IF uMsg==WM_INITDIALOG
   
        invoke  GetDlgItem,hWnd,IDC_EDIT
        invoke  SetWindowSubclass,eax,ADDR EditBox,0,0

    .ELSEIF uMsg==WM_CLOSE

        invoke  EndDialog,hWnd,NULL

    .ELSE

        mov     eax,FALSE
        ret

    .ENDIF

    mov     eax,TRUE
    ret

DlgProc ENDP

EditBox PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM,uIdSubClass:DWORD,dwRefData:DWORD

    .IF uMsg == WM_SETFOCUS || uMsg == WM_CONTEXTMENU || uMsg == WM_CHAR

        xor     eax,eax
        ret

    .ENDIF

    invoke  DefSubclassProc,hWnd,uMsg,wParam,lParam
    ret

EditBox ENDP

END start
